#include <iostream>
#include <queue>
#include <string>
#include <vector>
#include <unordered_set>
using namespace std;

int n, k;
string s;

char get(int pos)
{
	return s[(pos%n + n) % n];
}

bool canSolve(int start) 
{
	std::vector<int> be;
	for(int i = 0; i < k; i++)
	{
		char c = get(start + i);
		if(i == 0)
			be.push_back(-1);
		else
		{
			int p = i - 1;
			while(p > 0 && get(start + be[p] + 1) != c)
				p = be[p];
			if(p < 0 && get(start) != c)
				be.push_back(-1);
			else
				be.push_back(be[p] + 1]);
		}
	}
	
	std::queue<int> validUntil;
	int pos = start;
	int kmppos = -1;
	for(int i = 0; i < n; i++)
	{
		char c = get(pos);
		char cc = get(start + kmppos + 1);
		if(c == cc)
			kmppos++;
		else {
			while(c != get(start + kmppos + 1)) {
				cc = get(start + kmppos + 1);
				if(c < cc)
					validUntil.push(i + k - kmppos); // +-1?
				kmppos = be[kmppos] + 1;
				if(kmppos == 0)
					break;
			}
			if(kmppos == 0 && get(start + kmppos) != c) {
				if(get(start + kmppos) < c) {
					validUntil.push(i + k - kmppos); // +-1?
				}
				kmppos = -1;
			}
		}
		if(kmppos == -1) {
			while(!validUntil.empty() && validUntil.front() < pos)
				validUntil.pop();
			if(validUntil.empty())
				return false;
		}
		pos++;
	}
	return true;
}

int comp(int a, int b)
{
	
}

int main()
{
	cin >> n >> k;
	cin >> s;
}
