suits = 'DHCS'

def base_score(card):
    if card[0] in 'XJQKA':
        return 10
    return int(card[0])

def conv(card):
    if len(card) == 3:
        return ['X', card[2]]
    return list(card)

cards = list(map(conv, input().split()))
score = sum(map(base_score, cards))
modified = 0
last_mod = None

len_ = len
def len(x):
    return len_(list(x))

def rule1():
    global last_mod,  cards, score, modified
    if len(cards) >= 4:
        modified += 1
        score += 1
        last_mod = 1
        # inside if?
        score += len(x for x in cards if x[0] == 'J') * base_score(cards[0])

def rule2():
    global last_mod,  cards, score, modified
    for s in suits:
        if len(x for x in cards if x[1] == s) >= 2:
            score *= 2
            last_mod = 2
            modified += 1
            break

def rule3():
    global last_mod,  cards, score, modified
    if all(any(x for x in cards if x[1] == s) for s in suits):
        modified += 1
        score *= 2
        last_mod = 3

def rule4():
    global last_mod,  cards, score, modified
    diff = len(x for x in cards if x[1] in 'CS') - len(x for x in cards if x[1] not in 'CS')
    if diff != 0:
        score += abs(diff)
        modified += 1
        last_mod = 4

def rule5():
    global last_mod,  cards, score, modified
    if score % 2 == 0:
        bscore = score
        modified += 1
        last_mod = 5
        for i in range(1, bscore + 1):
            if bscore % i == 0:
                score += i

def rule6():
    global last_mod,  cards, score, modified
    if len(x for x in cards if x[0] == '7') == 4:
        modified += 1
        score -= 11**2
        last_mod = 6

def rule7():
    global last_mod,  cards, score, modified
    if score >= 0:
        modified += 1
        score += min(base_score(x) for x in cards)
        last_mod = 7

def rule8():
    global last_mod,  cards, score, modified
    if score < 0:
        modified += 1
        score = -1 * score
        last_mod = 8

def rule9():
    global last_mod,  cards, score, modified
    if len(x for x in cards if x[1] == 'D') >= 3:
        modified += 1
        score += 1
        last_mod = 9
        def ch(x):
            a, b = x
            if a == '6': a = '9'
            elif a == '9': a = '6'
            elif a == '2': a = '5'
            elif a == '5': a = '2'
            return [a, b]
        cards = [ch(x) for x in cards]

def rule10():
    global last_mod,  cards, score, modified
    baf = "23456789XJQKA"
    def buf(x):
        return baf.index(x)
    just_ranks = ''.join(sorted((r for r, _ in cards), key=buf))
    if just_ranks in "23456789XJQKA" and len(just_ranks) >= 5:
        score += 5 * len(x for x in cards if x[0] == 'A')
        if len(x for x in cards if x[0] == 'A') > 0:
            modified += 1
            last_mod = 10

def rule11():
    global last_mod,  cards, score, modified
    if modified > 8:
        if score != 0:
            modified += 1
            last_mod = 11
            score += len(x for x in bin(score)[2:] if x == '1')

def rule12():
    global last_mod,  cards, score, modified
    if len(x for x in cards if x[0] == '2'):
        exec("rule{}()".format(last_mod))

def rule13():
    global last_mod,  cards, score, modified
    
    if len(x for x in cards if x[0] == '2'):
        assert score != 0
        if score < 0:
            score = 0
        else:
            score *= 2
    
    

#print(score)
for i in range(1, 14):
    exec("rule{}()".format(i))
    #print("After rule {} score is {}".format(i, score))

print(score)
